## theano 0.7

=== benchmark/autoencoder/Makefile ===
aa.x : aa.cc
	g++ -O3 -ffast-math aa.cc -o aa.x -L${PUB_PREFIX}/lib -lgsl ${THEANO_BLAS_LDFLAGS}

clean : 
	rm aa.x

=== debian/changelog ===
theano (0.7-1) unstable; urgency=medium

  * Upload to unstable.
  * deb/control: updated uploader email address.

 -- Daniel Stender <stender@debian.org>  Sat, 25 Jun 2016 15:17:25 +0200

theano (0.7-1~exp1) experimental; urgency=medium

  * Initial release (Closes: #576540).

 -- Daniel Stender <debian@danielstender.com>  Thu, 25 Feb 2016 19:28:29 +0100

=== debian/control ===
Source: theano
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Daniel Stender <stender@debian.org>
Build-Depends:
 debhelper (>= 9),
 dh-python,
 python-all,
 python3-all,
 python-setuptools,
 python3-setuptools,
 python3-sphinx,
 python3-pygments
Standards-Version: 3.9.7
Homepage: http://www.deeplearning.net/software/theano/
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/theano.git
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/theano.git
X-Python-Version: >= 2.6
X-Python3-Version: >= 3.3

# nvidia-cuda-toolkit should be at least Recommends, but it's in Suggests here to
# keep the package in main (maybe Recommends would justify that, too). As soon
# as libgpuarray gets available that's going to get added to depends. That
# package employs the GPU for Theano via OpenCL (alternative backend), then non-free
# stuff is going to be not needed anymore for GPU accelerated computation at all

Package: python-theano
Architecture: all
Section: python
Depends:
 ${python:Depends},
 python-dev,
 libopenblas-dev,
 g++,
 ${misc:Depends}
Recommends:
 python-pydot,
 python-nose,
 theano-doc
Suggests:
 nvidia-cuda-toolkit,
 python-pycuda
Description: CPU/GPU math expression compiler for Python
 Theano is a Python library that allows one to define and evaluate mathematical
 expressions involving multi-dimensional arrays efficiently. It provides a
 high-level Numpy like expression language for functional description of
 calculation, rearranges expressions for speed and stability, and generates
 native machine instructions for fast calculation. Optionally, highly
 accelerated computations could be carried out on graphics cards processors.
 .
 This package contains Theano for Python 2.

# pycuda is demanded by some tests

Package: python3-theano
Architecture: all
Section: python
Depends:
 ${python3:Depends},
 python3-dev,
 libopenblas-dev,
 g++,
 ${misc:Depends}
Recommends:
 python3-pydot,
 python3-nose,
 theano-doc
Suggests:
 nvidia-cuda-toolkit,
 python3-pycuda
Description: CPU/GPU math expression compiler for Python 3
 Theano is a Python library that allows one to define and evaluate mathematical
 expressions involving multi-dimensional arrays efficiently. It provides a
 high-level Numpy like expression language for functional description of
 calculation, rearranges expressions for speed and stability, and generates
 native machine instructions for fast calculation. Optionally, highly
 accelerated computations could be carried out on graphics cards processors.
 .
 This package contains Theano for Python 3.

Package: theano-doc
Architecture: all
Section: doc
Depends:
 ${sphinxdoc:Depends},
 ${misc:Depends}
Recommends:
 python-theano,
 python3-theano
Description: CPU/GPU math expression compiler for Python (docs)
 Theano is a Python library that allows one to define and evaluate mathematical
 expressions involving multi-dimensional arrays efficiently. It provides a
 high-level Numpy like expression language for functional description of
 calculation, rearranges expressions for speed and stability, and generates
 native machine instructions for fast calculation. Optionally, highly
 accelerated computations could be carried out on graphics cards processors.
 .
 This package contains the documentation for Theano.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1
export PYBUILD_NAME=theano

export PYBUILD_INSTALL_ARGS=--install-scripts=/usr/share/{package} # for now

%:
	dh $@ --with python2,python3,sphinxdoc --buildsystem=pybuild

override_dh_auto_build:

override_dh_auto_test:
	# build-time tests disabled: non-accelerated testing takes veeery long (up to a hour)

override_dh_installdocs:
	dh_installdocs -A README.txt
	sphinx-build -N -bhtml doc/ debian/theano-doc/usr/share/doc/theano-doc/html/

=== debian/watch ===
version=3
opts="filenamemangle=s/(?:.*)?v?(\d[\d\.]+)\.tar\.gz/theano-$1.tar.gz/" \
https://github.com/theano/theano/releases (?:.*/)?rel-(\d[\d\.]+)\.tar\.gz

## theano 0.8.2

=== debian/changelog ===
theano (0.8.2-3) unstable; urgency=medium

  * Upload to unstable.
  * deb/control:
    + don't build on all supported archs.
    + move the info block on nvidia-cuda-toolkit down.
  * deb/rules:
    + narrow temporary failsafe down to i386 and s390x.
  * Dropped deb/README.Debian (obsolete).

 -- Daniel Stender <stender@debian.org>  Sat, 16 Jul 2016 18:33:21 +0200

theano (0.8.2-2) experimental; urgency=medium

  * deb/copyright:
    + split a paragraph.
  * deb/rules:
    + don't run tests on FAST_COMPILE (faster, but makes too many
      problems), and no arch solely on Python (not needed anymore).
  * strip-docs.patch:
    + remove `NEWS` (out-of-date) and `Download` (obsolete) from index.

 -- Daniel Stender <stender@debian.org>  Fri, 15 Jul 2016 15:34:00 +0200

theano (0.8.2-1) experimental; urgency=medium

  * New upstream release:
    + unfuzz strip-docs.patch.
  * deb/control:
    + add six to build deps.
    + add nose-parameterized to build and binary package deps.
    + use virtual libblas.so for the deps of binary packages.
  * deb/copyright:
    + add doc/.templates/layout.html to Files-Excluded (all privacy
      breaches).
    + updated (copyright span, new paragraphs).
  * deb/rules:
    + add empty config.cxx to THEANO_FLAGS on some archs (which are not
      recognizing Theano's default flags "-m32" and "-m64").
    + block web access for sphinx-build regardless.
    + add override for dh_compress.
    + rearrange logically.
  * deb/source/options:
    + add ignore pattern for egg-info directory.
  * add:
    + deb/README.Debian (with info on disabling compilation).
    + deb/missing-source (d3.js, dagre-d3.js, graphlib-dot.js).
    + deb/source.lintian-overrides.

 -- Daniel Stender <stender@debian.org>  Tue, 12 Jul 2016 11:06:03 +0200

theano (0.7-5) unstable; urgency=medium

  * deb/control: build with libblas-dev.

 -- Daniel Stender <stender@debian.org>  Sun, 10 Jul 2016 10:39:50 +0200

theano (0.7-4) unstable; urgency=medium

  * deb/control:
    + alternatively depend on libblas-dev (build and binary packages).
  * deb/rules:
    + fixed base_compiledir in export for THEANO_FLAGS.
    + added FAST_COMPILE mode switch to THEANO_FLAGS.
    + run tests with bin/theano-nose.

 -- Daniel Stender <stender@debian.org>  Sun, 10 Jul 2016 01:07:54 +0200

theano (0.7-3) unstable; urgency=medium

  * deb/control: use 'Architecture: any' for binary packages.
  * Dropped deb/source.lintian-overrides (no-arch-any).

 -- Daniel Stender <stender@debian.org>  Sat, 02 Jul 2016 18:22:31 +0200

theano (0.7-2) unstable; urgency=medium

  * Run build time tests (Closes: #824116):
    + complete dh_auto_test override in deb/rules.
    + add DEB_BUILD_OPTIONS export for nocheck (disabled by default).
    + add libopenblas-dev and python{,3}-nose to deb/control.
  * deb/control:
    + bump standards to 3.9.8 (no changes needed).
    + build depend against python{,3}-all-dev packages (needed for tests
      and docs).
    + add install_requires (numpy and scipy) to build-deps.
    + add rdfind and symlink to build deps.
    + build against python-sphinx (not yet ready for python3-sphinx),
      and python-pygments.
    + add dvipng and texlive-latex-extra to build deps (for ext.pngmath).
    + remove unnecessary comment text.
    + remove g++ from binary package deps (not needed fallback).
  * deb/copyright:
    + remove everything but .gitignore from Files-Excluded.
    + update email address.
  * deb/rules:
    + add export for THEANO_FLAGS with some needed configs (e.g. compiledir).
    + add override for dh_auto_install containing a custom removal.
    + add PYTHONPATH to sphinx-build.
    + run rdfind and symlinks in dh_installdocs override.
    + add removal for extra-license-file in docs package (dh_sphinxdoc
      override).
  * deb/watch:
    + improved filenamemangler.
  * Added deb/source.lintian-overrides.

 -- Daniel Stender <stender@debian.org>  Fri, 01 Jul 2016 23:26:54 +0200

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1
#export DEB_BUILD_OPTIONS=nocheck
export PYBUILD_NAME=theano

%:
	dh $@ --with python2,python3,sphinxdoc --buildsystem=pybuild

override_dh_auto_build:

export PYBUILD_INSTALL_ARGS=--install-scripts=/usr/share/{package}

override_dh_auto_install:
	dh_auto_install
	rm -fv debian/python*-theano/usr/lib/python*/dist-packages/theano/misc/check_blas_many.sh

export THEANO_FLAGS=base_compiledir='.pybuild',device=cpu

override_dh_auto_test:
ifneq (,$(filter i386 s390x,$(DEB_BUILD_ARCH)))
	PYBUILD_SYSTEM=custom PYBUILD_TEST_ARGS='PYTHONPATH=. {interpreter} bin/theano-nose -v' dh_auto_test || true
else
	PYBUILD_SYSTEM=custom PYBUILD_TEST_ARGS='PYTHONPATH=. {interpreter} bin/theano-nose -v' dh_auto_test
endif

override_dh_installdocs:
	dh_installdocs -A README.txt
	PYTHONPATH=. http_proxy='127.0.0.1:9' sphinx-build -N -bhtml doc/ debian/theano-doc/usr/share/doc/theano-doc/html/
	rdfind -outputname /dev/null -makesymlinks true debian/theano-doc
	symlinks -r -s -c debian/theano-doc

override_dh_sphinxdoc:
	dh_sphinxdoc
	rm -fv debian/theano-doc/usr/share/doc/theano-doc/html/_sources/LICENSE.txt # extra-license-file

override_dh_compress:
	dh_compress -X.py -X.ipynb -X.pdf # save theano-doc/html/_downloads

=== debian/watch ===
version=3
opts="filenamemangle=s/(?:.*)rel-(\d[\d\.]+)\.tar\.gz/theano-$1.tar.gz/" \
https://github.com/theano/theano/releases (?:.*/)?rel-(\d[\d\.]+)\.tar\.gz

## theano 0.9.0%2Bdfsg

=== doc/requirements.txt ===
.. |PlatformCompiler| replace:: ``g++`` (Linux and Windows), ``clang`` (OS X)

.. include:: requirements.inc

## theano 0.9.0+dfsg

=== debian/changelog ===
theano (0.9.0+dfsg-2) unstable; urgency=medium

  * Team upload.
  [ Rebecca Palmer ]
  * Really remove the pre-minified Javascript.
  * Fix test failures on big-endian systems.  (Closes: #878596)

 -- Daniel Stender <stender@debian.org>  Wed, 08 Nov 2017 08:09:59 +0100

theano (0.9.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Drop patches applied upstream, refresh others.
  * Only remove the privacy-violating part of doc/index.txt,
    not all of News and Download.
  * Change Uploaders.  (Closes: #852138)
  * Update and sort d/copyright.
  * Disable another wall-clock speed test (similar to #835531).
  * Bump Standards-Version to 4.1.1 (no changes needed).
  * Bump compat to 10.
  * Recommend python(3)-pygpu and g++.
  * Use the Python 3 versions of sphinx and pygments.
  * Build-depend on python3-sphinx-rtd-theme.
  * Use the version in doc->source links,
    not a (usually non-existent) git commit number.
  * Make tests work with older nose-parameterized.
  * Use python(3)-dev not -all-dev.  (Closes: #867370)
  * Remove pre-minified Javascript, and instead minify at build time.
  * Use libjs-d3 instead of the embedded copy, but re-minify to
    work around #745688.
  * Clean up properly after build.
  * Use Suggests, not Recommends, between package and documentation.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Sat, 30 Sep 2017 13:50:38 +0100

theano (0.8.2-6) unstable; urgency=medium

  * Upload to unstable.

 -- Daniel Stender <stender@debian.org>  Wed, 15 Feb 2017 09:09:46 +0100

theano (0.8.2-6~exp1) experimental; urgency=medium

  * add disable-overly-environment-dependent-test.patch (Closes: #835531).
  * add fix-invalid-casts-negative-stride-handling.patch
    (Closes: #831541,#855102) [thanks again to Rebecca N. Palmer].

 -- Daniel Stender <stender@debian.org>  Wed, 15 Feb 2017 00:08:13 +0100

theano (0.8.2-5) unstable; urgency=medium

  *  Upload to unstable. 

 -- Daniel Stender <stender@debian.org>  Tue, 14 Feb 2017 09:47:30 +0100

theano (0.8.2-5~exp1) experimental; urgency=medium

  * add fix-test_fit_int64-for-python3-32bit.patch (Closes: #831540)
    [thanks to Rebecca N. Palmer].
  * deb/rules: remove test failsafes completely.

 -- Daniel Stender <stender@debian.org>  Mon, 13 Feb 2017 23:53:19 +0100

theano (0.8.2-4) unstable; urgency=medium

  * add fixes-for-numpy-1.12.patch (Closes: #848764) [thanks to
    Rebecca N. Palmer].

 -- Daniel Stender <stender@debian.org>  Mon, 13 Feb 2017 15:04:06 +0100

=== debian/control ===
--- 
+++ 
@@ -3,45 +3,67 @@
 Priority: optional
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders:
- Daniel Stender <stender@debian.org>
+ Rebecca N. Palmer <rebecca_palmer@zoho.com>, Ghislain Antony Vaillant <ghisvail@gmail.com>
 Build-Depends:
- debhelper (>= 9),
+ debhelper (>= 10),
  dh-python,
- python-all,
- python3-all,
+ python-dev,
+ python3-dev,
  python-setuptools,
  python3-setuptools,
+ python-six,
+ python3-six,
+ libblas-dev,
+ python-numpy,
+ python3-numpy,
+ python-scipy,
+ python3-scipy,
+ python-nose,
+ python3-nose,
+ python-nose-parameterized,
+ python3-nose-parameterized,
+# No python(3)-pygpu because clblas doesn't work under pocl-opencl-icd (no mem_fence) and buildds are unlikely to have a real GPU
  python3-sphinx,
- python3-pygments
-Standards-Version: 3.9.7
+ python3-sphinx-rtd-theme,
+ python3-pygments,
+ dvipng,
+ texlive-latex-extra,
+ rdfind,
+ symlinks,
+ node-browserify-lite,
+ node-uglify,
+ node-pegjs,
+ node-lodash-compat,
+ libjs-d3
+Standards-Version: 4.1.1
 Homepage: http://www.deeplearning.net/software/theano/
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/theano.git
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/theano.git
 X-Python-Version: >= 2.6
 X-Python3-Version: >= 3.3
 
-# nvidia-cuda-toolkit should be at least Recommends, but it's in Suggests here to
-# keep the package in main (maybe Recommends would justify that, too). As soon
-# as libgpuarray gets available that's going to get added to depends. That
-# package employs the GPU for Theano via OpenCL (alternative backend), then non-free
-# stuff is going to be not needed anymore for GPU accelerated computation at all
+# omit archs which have NotImplementedErrors on non-aligned arrays during the tests and/or
+# having problems with the build flags (-m32/-m64), but also with disabled compilation (by cxx='').
 
 Package: python-theano
-Architecture: all
+Architecture: amd64 arm64 i386 ppc64el s390x hurd-i386 kfreebsd-amd64 kfreebsd-i386 ppc64 sh4 sparc64 x32
 Section: python
 Depends:
  ${python:Depends},
  python-dev,
- libopenblas-dev,
- g++,
+ libblas-dev | libblas.so,
  ${misc:Depends}
 Recommends:
+ g++,
  python-pydot,
  python-nose,
- theano-doc
+ python-nose-parameterized,
+ python-pygpu
 Suggests:
  nvidia-cuda-toolkit,
- python-pycuda
+ python-pycuda,
+ theano-doc
+Built-Using: ${javascriptBU}
 Description: CPU/GPU math expression compiler for Python
  Theano is a Python library that allows one to define and evaluate mathematical
  expressions involving multi-dimensional arrays efficiently. It provides a
@@ -52,24 +74,28 @@
  .
  This package contains Theano for Python 2.
 
-# pycuda is demanded by some tests
+# nvidia-cuda-toolkit should be at least Recommends, but it's in Suggests here to
+# keep the package in main.
 
 Package: python3-theano
-Architecture: all
+Architecture: amd64 arm64 i386 ppc64el s390x hurd-i386 kfreebsd-amd64 kfreebsd-i386 ppc64 sh4 sparc64 x32
 Section: python
 Depends:
  ${python3:Depends},
  python3-dev,
- libopenblas-dev,
- g++,
+ libblas-dev | libblas.so,
  ${misc:Depends}
 Recommends:
+ g++,
  python3-pydot,
  python3-nose,
- theano-doc
+ python3-nose-parameterized,
+ python3-pygpu
 Suggests:
  nvidia-cuda-toolkit,
- python3-pycuda
+ python3-pycuda,
+ theano-doc
+Built-Using: ${javascriptBU}
 Description: CPU/GPU math expression compiler for Python 3
  Theano is a Python library that allows one to define and evaluate mathematical
  expressions involving multi-dimensional arrays efficiently. It provides a
@@ -86,9 +112,9 @@
 Depends:
  ${sphinxdoc:Depends},
  ${misc:Depends}
-Recommends:
- python-theano,
- python3-theano
+Suggests:
+ python3-theano | python-theano
+Built-Using: ${javascriptBU}
 Description: CPU/GPU math expression compiler for Python (docs)
  Theano is a Python library that allows one to define and evaluate mathematical
  expressions involving multi-dimensional arrays efficiently. It provides a

=== debian/rules ===
--- 
+++ 
@@ -2,11 +2,28 @@
 #export DH_VERBOSE=1
 #export DEB_BUILD_OPTIONS=nocheck
 export PYBUILD_NAME=theano
+export NODE_PATH=$(CURDIR)/debian/missing-source
 
 %:
 	dh $@ --with python2,python3,sphinxdoc --buildsystem=pybuild
 
+override_dh_auto_clean:
+	rm -rf theano/d3viz/js/*.min.js doc/library/d3viz/examples/d3viz/js/*.min.js debian/missing-source/*.js debian/missing-source/lodash debian/missing-source/graphlib-dot/bower.json debian/missing-source/graphlib-dot/lib/dot-grammar.js debian/missing-source/graphlib-dot/lib/version.js debian/missing-source/graphlib-dot/dist doc/.pybuild Theano.egg-info
+	make -C debian/missing-source/graphlib-dot clean
+	dh_auto_clean
+
 override_dh_auto_build:
+	ln -s /usr/lib/nodejs/lodash-compat debian/missing-source/lodash
+	#graphlib-dot.js
+	make -C debian/missing-source/graphlib-dot --always-make dist
+	cp debian/missing-source/graphlib-dot/dist/graphlib-dot.min.js theano/d3viz/js
+	#dagre-d3.js
+	browserify-lite ./debian/missing-source/dagre-d3/index.js --outfile debian/missing-source/dagre-d3.js --standalone dagreD3
+	uglifyjs debian/missing-source/dagre-d3.js --comments '@license' -o theano/d3viz/js/dagre-d3.min.js
+	#d3 - workaround for #745688
+	uglifyjs /usr/share/javascript/d3/d3.js -m -c --comments '@license' -o theano/d3viz/js/d3.v3.min.js
+	cp theano/d3viz/js/*.min.js doc/library/d3viz/examples/d3viz/js
+	#theano itself doesn't need a build as such
 
 export PYBUILD_INSTALL_ARGS=--install-scripts=/usr/share/{package}
 
@@ -17,11 +34,7 @@
 export THEANO_FLAGS=base_compiledir='.pybuild',device=cpu
 
 override_dh_auto_test:
-ifneq (,$(filter i386 s390x,$(DEB_BUILD_ARCH)))
-	PYBUILD_SYSTEM=custom PYBUILD_TEST_ARGS='PYTHONPATH=. {interpreter} bin/theano-nose -v' dh_auto_test || true
-else
 	PYBUILD_SYSTEM=custom PYBUILD_TEST_ARGS='PYTHONPATH=. {interpreter} bin/theano-nose -v' dh_auto_test
-endif
 
 override_dh_installdocs:
 	dh_installdocs -A README.txt
@@ -35,3 +48,6 @@
 
 override_dh_compress:
 	dh_compress -X.py -X.ipynb -X.pdf # save theano-doc/html/_downloads
+
+override_dh_gencontrol:
+	dh_gencontrol -- -VjavascriptBU="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), \n' -W node-lodash-compat)$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), \n' -W libjs-d3)"

=== debian/watch ===
version=3
opts="filenamemangle=s/(?:.*)rel-(\d[\d\.]+)\.tar\.gz/theano-$1.tar.gz/,repacksuffix=+dfsg2,dversionmangle=s/\+dfsg[0-9]*//" \
https://github.com/theano/theano/releases (?:.*/)?rel-(\d[\d\.]+)\.tar\.gz

## theano 1.0.1+dfsg

=== debian/changelog ===
theano (1.0.1+dfsg-2ubuntu1) cosmic; urgency=medium

  * Split the test suite to avoid OOM on arm64 and ppc64el,
    thanks Rebecca N. Palmer (LP: #1769672)

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 12 May 2018 07:48:47 +0000

theano (1.0.1+dfsg-2) unstable; urgency=medium

  * Recommend python(3)-parameterized instead of -nose-parameterized,
    and add python(3)-pkg-resources.
  * Set allow-stderr on import tests.
  * Remove X-Python3-Version.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Sun, 06 May 2018 11:02:28 +0100

theano (1.0.1+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Drop 878596.patch, applied upstream.
  * Switch to python(3)-parameterized,
    drop old-nose-parameterized.patch.
  * Refresh patches.
  * Change Vcs-* to Salsa.
  * Remove X-Python-Version, update X-Python3-Version.
  * Update and improve d/copyright.
  * Add Cython dependencies, rebuild Cython-generated C code.
  * Use upstream's script for building documentation, but also build
    README.html.  Support nodoc.
  * Use local rather than web links within documentation.
  * Recommend graphviz (for printing/d3viz), accept python-pydot-ng,
    and build-depend on them to allow testing.
  * Bump debhelper compat to 11.
  * Bump Standards-Version to 4.1.4 (no changes needed).
  * Add d/upstream/metadata.
  * Warn that upstream development is ending.
  * Add Breaks: on older versions of lasagne (see #893656).
  * Set Rules-Requires-Root: no.
  * Add autopkgtests.
  * Clarify cache directory permission errors (see #896220, #896421).

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Sat, 05 May 2018 11:03:51 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,18 @@
 Source: theano
 Section: science
 Priority: optional
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders:
  Rebecca N. Palmer <rebecca_palmer@zoho.com>, Ghislain Antony Vaillant <ghisvail@gmail.com>
 Build-Depends:
- debhelper (>= 10),
+#for the build proper
+ debhelper (>= 11),
  dh-python,
+ cython,
+ cython3,
+#runtime dependencies - needed for the test suite and for the documentation build
+# No python(3)-pygpu because clblas doesn't work under pocl-opencl-icd (no mem_fence) and buildds are unlikely to have a real GPU
  python-dev,
  python3-dev,
  python-setuptools,
@@ -20,27 +26,33 @@
  python3-scipy,
  python-nose,
  python3-nose,
- python-nose-parameterized,
- python3-nose-parameterized,
-# No python(3)-pygpu because clblas doesn't work under pocl-opencl-icd (no mem_fence) and buildds are unlikely to have a real GPU
+ python-parameterized,
+ python3-parameterized,
+ python-pydot-ng | python-pydot,
+ python3-pydot,
+ graphviz,
+#for the documentation build
+ python3-docutils,
  python3-sphinx,
  python3-sphinx-rtd-theme,
  python3-pygments,
  dvipng,
  texlive-latex-extra,
+ texlive-fonts-recommended,
+ latexmk,
  rdfind,
  symlinks,
+#for building Javascript dependencies (of d3viz)
  node-browserify-lite,
  node-uglify,
  node-pegjs,
  node-lodash-compat,
  libjs-d3
-Standards-Version: 4.1.1
+Rules-Requires-Root: no
+Standards-Version: 4.1.4
 Homepage: http://www.deeplearning.net/software/theano/
-Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/theano.git
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/theano.git
-X-Python-Version: >= 2.6
-X-Python3-Version: >= 3.3
+Vcs-Git: https://salsa.debian.org/science-team/theano.git
+Vcs-Browser: https://salsa.debian.org/science-team/theano
 
 # omit archs which have NotImplementedErrors on non-aligned arrays during the tests and/or
 # having problems with the build flags (-m32/-m64), but also with disabled compilation (by cxx='').
@@ -55,14 +67,18 @@
  ${misc:Depends}
 Recommends:
  g++,
- python-pydot,
+ python-pydot | python-pydot-ng,
  python-nose,
- python-nose-parameterized,
- python-pygpu
+ python-parameterized,
+ python-pkg-resources,
+ python-pygpu,
+ cython,
+ graphviz
 Suggests:
  nvidia-cuda-toolkit,
  python-pycuda,
  theano-doc
+Breaks: python-lasagne (<< 0.1+git20180322.37ca134)
 Built-Using: ${javascriptBU}
 Description: CPU/GPU math expression compiler for Python
  Theano is a Python library that allows one to define and evaluate mathematical
@@ -73,6 +89,8 @@
  accelerated computations could be carried out on graphics cards processors.
  .
  This package contains Theano for Python 2.
+ .
+ Theano development is ending: consider using Caffe or Torch instead.
 
 # nvidia-cuda-toolkit should be at least Recommends, but it's in Suggests here to
 # keep the package in main.
@@ -89,12 +107,16 @@
  g++,
  python3-pydot,
  python3-nose,
- python3-nose-parameterized,
- python3-pygpu
+ python3-parameterized,
+ python3-pkg-resources,
+ python3-pygpu,
+ cython3,
+ graphviz
 Suggests:
  nvidia-cuda-toolkit,
  python3-pycuda,
  theano-doc
+Breaks: python3-lasagne (<< 0.1+git20180322.37ca134)
 Built-Using: ${javascriptBU}
 Description: CPU/GPU math expression compiler for Python 3
  Theano is a Python library that allows one to define and evaluate mathematical
@@ -105,6 +127,8 @@
  accelerated computations could be carried out on graphics cards processors.
  .
  This package contains Theano for Python 3.
+ .
+ Theano development is ending: consider using Caffe or Torch instead.
 
 Package: theano-doc
 Architecture: all

=== debian/rules ===
--- 
+++ 
@@ -3,12 +3,14 @@
 #export DEB_BUILD_OPTIONS=nocheck
 export PYBUILD_NAME=theano
 export NODE_PATH=$(CURDIR)/debian/missing-source
+export PYBUILD_INSTALL_ARGS=--install-scripts=/usr/share/{package}
+export THEANO_FLAGS=base_compiledir='.pybuild',device=cpu
 
 %:
 	dh $@ --with python2,python3,sphinxdoc --buildsystem=pybuild
 
 override_dh_auto_clean:
-	rm -rf theano/d3viz/js/*.min.js doc/library/d3viz/examples/d3viz/js/*.min.js debian/missing-source/*.js debian/missing-source/lodash debian/missing-source/graphlib-dot/bower.json debian/missing-source/graphlib-dot/lib/dot-grammar.js debian/missing-source/graphlib-dot/lib/version.js debian/missing-source/graphlib-dot/dist doc/.pybuild Theano.egg-info
+	rm -rf theano/d3viz/js/*.min.js doc/library/d3viz/examples/d3viz/js/*.min.js debian/missing-source/*.js debian/missing-source/lodash debian/missing-source/graphlib-dot/bower.json debian/missing-source/graphlib-dot/lib/dot-grammar.js debian/missing-source/graphlib-dot/lib/version.js debian/missing-source/graphlib-dot/dist doc/.pybuild Theano.egg-info theano/scan_module/c_code/scan_perform.c
 	make -C debian/missing-source/graphlib-dot clean
 	dh_auto_clean
 
@@ -23,24 +25,28 @@
 	#d3 - workaround for #745688
 	uglifyjs /usr/share/javascript/d3/d3.js -m -c --comments '@license' -o theano/d3viz/js/d3.v3.min.js
 	cp theano/d3viz/js/*.min.js doc/library/d3viz/examples/d3viz/js
-	#theano itself doesn't need a build as such
-
-export PYBUILD_INSTALL_ARGS=--install-scripts=/usr/share/{package}
+	#the cython code is the only part of theano itself that needs building - the C code is runtime compiled
+	cd theano/scan_module && cython3 scan_perform.pyx && patch --no-backup-if-mismatch scan_perform.c numpy_api_changes.diff && mv scan_perform.c -t c_code
+	#documentation
+ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
+	python3 doc/scripts/docgen.py
+	rst2html README.rst README.html
+endif
 
 override_dh_auto_install:
 	dh_auto_install
 	rm -fv debian/python*-theano/usr/lib/python*/dist-packages/theano/misc/check_blas_many.sh
 
-export THEANO_FLAGS=base_compiledir='.pybuild',device=cpu
 
 override_dh_auto_test:
-	PYBUILD_SYSTEM=custom PYBUILD_TEST_ARGS='PYTHONPATH=. {interpreter} bin/theano-nose -v' dh_auto_test
+	PYBUILD_SYSTEM=custom PYBUILD_TEST_ARGS='PYTHONPATH=. {interpreter} theano/tests/run_tests_in_batch.py -v' dh_auto_test
 
 override_dh_installdocs:
-	dh_installdocs -A README.txt
-	PYTHONPATH=. http_proxy='127.0.0.1:9' sphinx-build -N -bhtml doc/ debian/theano-doc/usr/share/doc/theano-doc/html/
+	dh_installdocs -A README.html
+ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
 	rdfind -outputname /dev/null -makesymlinks true debian/theano-doc
 	symlinks -r -s -c debian/theano-doc
+endif
 
 override_dh_sphinxdoc:
 	dh_sphinxdoc

## theano 1.0.2+dfsg

=== debian/changelog ===
theano (1.0.2+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Split up the test suite to avoid running out of memory
    (workaround for #898126 / LP#1769672), but don't hide output.
  * Rebuild doc/library/d3viz/*.html, and tell Lintian where their
    source is.
    (This is unreproducible as some of them contain profiling output,
    but we're unreproducible anyway due to uglifyjs.)

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Fri, 15 Jun 2018 08:23:45 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: theano
 Section: science
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders:
  Rebecca N. Palmer <rebecca_palmer@zoho.com>, Ghislain Antony Vaillant <ghisvail@gmail.com>
 Build-Depends:
@@ -42,6 +41,7 @@
  latexmk,
  rdfind,
  symlinks,
+ jupyter-nbconvert, python3-ipykernel,
 #for building Javascript dependencies (of d3viz)
  node-browserify-lite,
  node-uglify,

=== debian/rules ===
--- 
+++ 
@@ -5,12 +5,14 @@
 export NODE_PATH=$(CURDIR)/debian/missing-source
 export PYBUILD_INSTALL_ARGS=--install-scripts=/usr/share/{package}
 export THEANO_FLAGS=base_compiledir='.pybuild',device=cpu
+export PYTHONPATH=$(CURDIR)
+export HOME=$(CURDIR)/jupyter_tmp
 
 %:
 	dh $@ --with python2,python3,sphinxdoc --buildsystem=pybuild
 
 override_dh_auto_clean:
-	rm -rf theano/d3viz/js/*.min.js doc/library/d3viz/examples/d3viz/js/*.min.js debian/missing-source/*.js debian/missing-source/lodash debian/missing-source/graphlib-dot/bower.json debian/missing-source/graphlib-dot/lib/dot-grammar.js debian/missing-source/graphlib-dot/lib/version.js debian/missing-source/graphlib-dot/dist doc/.pybuild Theano.egg-info theano/scan_module/c_code/scan_perform.c
+	rm -rf theano/d3viz/js/*.min.js doc/library/d3viz/examples/d3viz/js/*.min.js debian/missing-source/*.js debian/missing-source/lodash debian/missing-source/graphlib-dot/bower.json debian/missing-source/graphlib-dot/lib/dot-grammar.js debian/missing-source/graphlib-dot/lib/version.js debian/missing-source/graphlib-dot/dist doc/.pybuild doc/library/d3viz/.pybuild Theano.egg-info theano/scan_module/c_code/scan_perform.c jupyter_tmp
 	make -C debian/missing-source/graphlib-dot clean
 	dh_auto_clean
 
@@ -29,6 +31,11 @@
 	cd theano/scan_module && cython3 scan_perform.pyx && patch --no-backup-if-mismatch scan_perform.c numpy_api_changes.diff && mv scan_perform.c -t c_code
 	#documentation
 ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
+	sed -i -e "s/!pip/#!pip/g" doc/library/d3viz/index.ipynb
+	mkdir jupyter_tmp
+	jupyter-nbconvert --to notebook --execute --allow-errors doc/library/d3viz/index.ipynb || exit 0
+	jupyter-nbconvert --to html doc/library/d3viz/index.nbconvert.ipynb || exit 0
+	sed -i -e "s/#!pip/!pip/g" doc/library/d3viz/index.ipynb
 	python3 doc/scripts/docgen.py
 	rst2html README.rst README.html
 endif
@@ -39,7 +46,7 @@
 
 
 override_dh_auto_test:
-	PYBUILD_SYSTEM=custom PYBUILD_TEST_ARGS='PYTHONPATH=. {interpreter} theano/tests/run_tests_in_batch.py -v' dh_auto_test
+	PYBUILD_SYSTEM=custom PYBUILD_TEST_ARGS='PYTHONPATH=. {interpreter} theano/tests/run_tests_in_batch.py' dh_auto_test
 
 override_dh_installdocs:
 	dh_installdocs -A README.html

=== debian/tests/control ===
Test-Command: python debian/tests/import
Depends: python-theano
Restrictions: allow-stderr

Test-Command: python3 debian/tests/import
Depends: python3-theano
Restrictions: allow-stderr

Test-Command: env TEST_PYTHON=python debian/tests/selected_upstream_tests
Depends: python-theano
Restrictions: needs-recommends, allow-stderr

Test-Command: env TEST_PYTHON=python3 debian/tests/selected_upstream_tests
Depends: python3-theano
Restrictions: needs-recommends, allow-stderr

## theano 1.0.3+dfsg

=== debian/changelog ===
theano (1.0.3+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patch.
  * Don't list the old upstream as contact.
  * Install release notes as NEWS.gz to comply with
    Standards-Version 4.3.0.
  * tests: Stop using deprecated needs-recommends.
  * Fix crash with numpy 1.16.  (Closes: #918090)
  * Check that d3viz profiling runs but, for reproducibility,
    don't regenerate the profiling output in the documentation.
  * Don't apply numpy_api_changes.diff when using Cython >= 0.29,
    as the code it patches no longer exists.  (Closes: #918771)

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Thu, 10 Jan 2019 19:12:25 +0000

=== debian/control ===
--- 
+++ 
@@ -49,7 +49,7 @@
  node-lodash-compat,
  libjs-d3
 Rules-Requires-Root: no
-Standards-Version: 4.1.4
+Standards-Version: 4.3.0
 Homepage: http://www.deeplearning.net/software/theano/
 Vcs-Git: https://salsa.debian.org/science-team/theano.git
 Vcs-Browser: https://salsa.debian.org/science-team/theano

=== debian/rules ===
--- 
+++ 
@@ -28,16 +28,22 @@
 	uglifyjs /usr/share/javascript/d3/d3.js -m -c --comments '@license' -o theano/d3viz/js/d3.v3.min.js
 	cp theano/d3viz/js/*.min.js doc/library/d3viz/examples/d3viz/js
 	#the cython code is the only part of theano itself that needs building - the C code is runtime compiled
-	cd theano/scan_module && cython3 scan_perform.pyx && patch --no-backup-if-mismatch scan_perform.c numpy_api_changes.diff && mv scan_perform.c -t c_code
+	#the patch is to code Cython copies from itself (Cython/Includes/numpy/__init__.pxd), that only exists in older versions - #918771
+	cd $(CURDIR)/theano/scan_module && cython3 scan_perform.pyx
+	cd $(CURDIR)/theano/scan_module && dpkg --compare-versions `dpkg-query -f '$${Version}' -W cython3` gt 0.29~ || patch --no-backup-if-mismatch scan_perform.c numpy_api_changes.diff
+	cd $(CURDIR)/theano/scan_module && mv scan_perform.c -t c_code
 	#documentation
 ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
 	sed -i -e "s/!pip/#!pip/g" doc/library/d3viz/index.ipynb
 	mkdir jupyter_tmp
-	jupyter-nbconvert --to notebook --execute --allow-errors doc/library/d3viz/index.ipynb || exit 0
-	jupyter-nbconvert --to html doc/library/d3viz/index.nbconvert.ipynb || exit 0
+	#check that we can run this, but throw away the result because it's unreproducible (profiling output)
+	cp $(CURDIR)/doc/library/d3viz/index.ipynb jupyter_tmp && jupyter-nbconvert --to notebook --execute $(CURDIR)/jupyter_tmp/index.ipynb --output $(CURDIR)/jupyter_tmp/test.ipynb
+	#...but do use the ipynb-to-html-etc conversion
+	jupyter-nbconvert --to html doc/library/d3viz/index.ipynb
 	sed -i -e "s/#!pip/!pip/g" doc/library/d3viz/index.ipynb
 	python3 doc/scripts/docgen.py
 	rst2html README.rst README.html
+	cat NEWS.txt HISTORY.txt | gzip -n -9 > NEWS.gz
 endif
 
 override_dh_auto_install:
@@ -49,11 +55,15 @@
 	PYBUILD_SYSTEM=custom PYBUILD_TEST_ARGS='PYTHONPATH=. {interpreter} theano/tests/run_tests_in_batch.py' dh_auto_test
 
 override_dh_installdocs:
-	dh_installdocs -A README.html
+	dh_installdocs -A README.html NEWS.gz
 ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
 	rdfind -outputname /dev/null -makesymlinks true debian/theano-doc
 	symlinks -r -s -c debian/theano-doc
 endif
+
+override_dh_installchangelogs:
+	#the -X is meant as "don't try to install upstream changelog, only Debian's" - #906827
+	dh_installchangelogs -Xtxt
 
 override_dh_sphinxdoc:
 	dh_sphinxdoc

=== debian/tests/control ===
Test-Command: python debian/tests/import
Depends: python-theano
Restrictions: allow-stderr

Test-Command: python3 debian/tests/import
Depends: python3-theano
Restrictions: allow-stderr

Test-Command: env TEST_PYTHON=python debian/tests/selected_upstream_tests
Depends: python-theano,
 g++,
 python-pydot | python-pydot-ng,
 python-nose,
 python-parameterized,
 python-pkg-resources,
 cython,
 graphviz
Restrictions: allow-stderr

Test-Command: env TEST_PYTHON=python3 debian/tests/selected_upstream_tests
Depends: python3-theano,
 g++,
 python3-pydot,
 python3-nose,
 python3-parameterized,
 python3-pkg-resources,
 cython3,
 graphviz
Restrictions: allow-stderr

=== debian/watch ===
version=3
opts="filenamemangle=s/(?:.*)rel-(\d[\d\.]+)\.tar\.gz/theano-$1.tar.gz/,repacksuffix=+dfsg,dversionmangle=s/\+dfsg[0-9]*//" \
https://github.com/theano/theano/releases (?:.*/)?rel-(\d[\d\.]+)\.tar\.gz

## theano 1.0.4+dfsg

=== doc/hpcs2011_tutorial/Makefile ===
all: presentation.pdf

presentation.pdf: presentation.tex pics/f_optimized.png pics/logreg_pydotprint_prediction.png
# pics/f_unoptimized.png pics/logreg_pydotprint_predic.png pics/logreg_pydotprint_train.png
	pdflatex presentation.tex

pics/f_optimized.png: simple_example.py
	python simple_example.py

pics/logreg_pydotprint_prediction.png: logreg_example.py
	python logreg_example.py
#pics/f_unoptimized.png: simple_example.py
#	python simple_example.py

=== doc/nextml2015/Makefile ===
presentation.pdf: presentation.tex
	pdflatex presentation.tex
	pdflatex presentation.tex

clean:
	rm *.toc *.snm *.aux *.log *.nav *.out *.vrb

=== debian/changelog ===
theano (1.0.4+dfsg-1build1) focal; urgency=medium

  * No-change rebuild to build with python3.8.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 25 Jan 2020 05:44:37 +0000

theano (1.0.4+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Drop patch applied upstream, refresh others.
  * Drop Python 2 package (see #938661) and avoid Python 2 use.
  * Bump Standards-Version to 4.4.1 (no changes needed).
  * Bump debhelper compat to 12 and use debhelper-compat.
  * Remove broken documentation link.
  * Reproducibility: strip build path dependence from Cython output.
  * Attempt build on all architectures.  (Some will probably fail.)
  * Recommend libgpuarray-dev.
  * Warn that OpenCL support may be buggy,
    but test that it isn't totally broken.
  * Rename autopkgtests to remove forbidden characters.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Mon, 04 Nov 2019 21:17:14 +0000

=== debian/control ===
Source: theano
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Rebecca N. Palmer <rebecca_palmer@zoho.com>
Build-Depends:
#for the build proper
 debhelper-compat (= 12),
 dh-python,
 cython3,
#runtime dependencies - needed for the test suite and for the documentation build
# No python3-pygpu etc because some GPU tests are known to fail under OpenCL
 python3-dev,
 python3-setuptools,
 python3-six,
 libblas-dev,
 python3-numpy,
 python3-scipy,
 python3-nose,
 python3-parameterized,
 python3-pydot,
 graphviz,
#for the documentation build
 python3-docutils,
 python3-sphinx,
 python3-sphinx-rtd-theme,
 python3-pygments,
 dvipng,
 texlive-latex-extra,
 texlive-fonts-recommended,
 latexmk,
 rdfind,
 symlinks,
 jupyter-nbconvert, python3-ipykernel,
#for building Javascript dependencies (of d3viz)
 node-browserify-lite,
 node-uglify,
 node-pegjs,
 node-lodash-compat,
 libjs-d3
Rules-Requires-Root: no
Standards-Version: 4.4.1
Homepage: http://www.deeplearning.net/software/theano/
Vcs-Git: https://salsa.debian.org/science-team/theano.git
Vcs-Browser: https://salsa.debian.org/science-team/theano

# nvidia-cuda-toolkit should be at least Recommends, but it's in Suggests here to
# keep the package in main.

Package: python3-theano
Architecture: any
Section: python
Depends:
 ${python3:Depends},
 python3-dev,
 libblas-dev | libblas.so,
 ${misc:Depends}
Recommends:
 g++,
 python3-pydot,
 python3-nose,
 python3-parameterized,
 python3-pkg-resources,
 python3-pygpu,
 libgpuarray-dev,
 cython3,
 graphviz
Suggests:
 nvidia-cuda-toolkit,
 python3-pycuda,
 theano-doc
Breaks: python3-lasagne (<< 0.1+git20180322.37ca134)
Built-Using: ${javascriptBU}
Description: CPU/GPU math expression compiler for Python 3
 Theano is a Python library that allows one to define and evaluate mathematical
 expressions involving multi-dimensional arrays efficiently. It provides a
 high-level Numpy like expression language for functional description of
 calculation, rearranges expressions for speed and stability, and generates
 native machine instructions for fast calculation. Optionally, highly
 accelerated computations could be carried out on graphics cards processors.
 .
 This package contains Theano for Python 3.
 .
 Theano development is ending: consider using Caffe or Torch instead.

Package: theano-doc
Architecture: all
Section: doc
Depends:
 ${sphinxdoc:Depends},
 ${misc:Depends}
Suggests:
 python3-theano
Built-Using: ${javascriptBU}
Description: CPU/GPU math expression compiler for Python (docs)
 Theano is a Python library that allows one to define and evaluate mathematical
 expressions involving multi-dimensional arrays efficiently. It provides a
 high-level Numpy like expression language for functional description of
 calculation, rearranges expressions for speed and stability, and generates
 native machine instructions for fast calculation. Optionally, highly
 accelerated computations could be carried out on graphics cards processors.
 .
 This package contains the documentation for Theano.

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,7 @@
 export HOME=$(CURDIR)/jupyter_tmp
 
 %:
-	dh $@ --with python2,python3,sphinxdoc --buildsystem=pybuild
+	dh $@ --with python3,sphinxdoc --buildsystem=pybuild
 
 override_dh_auto_clean:
 	rm -rf theano/d3viz/js/*.min.js doc/library/d3viz/examples/d3viz/js/*.min.js debian/missing-source/*.js debian/missing-source/lodash debian/missing-source/graphlib-dot/bower.json debian/missing-source/graphlib-dot/lib/dot-grammar.js debian/missing-source/graphlib-dot/lib/version.js debian/missing-source/graphlib-dot/dist doc/.pybuild doc/library/d3viz/.pybuild Theano.egg-info theano/scan_module/c_code/scan_perform.c jupyter_tmp
@@ -28,8 +28,10 @@
 	uglifyjs /usr/share/javascript/d3/d3.js -m -c --comments '@license' -o theano/d3viz/js/d3.v3.min.js
 	cp theano/d3viz/js/*.min.js doc/library/d3viz/examples/d3viz/js
 	#the cython code is the only part of theano itself that needs building - the C code is runtime compiled
-	#the patch is to code Cython copies from itself (Cython/Includes/numpy/__init__.pxd), that only exists in older versions - #918771
 	cd $(CURDIR)/theano/scan_module && cython3 scan_perform.pyx
+	#remove relative paths from comments - they are unreproducible (depends on the number of levels in the build path) and probably wrong when installed
+	cd $(CURDIR)/theano/scan_module && sed -iE -e 's#/\* "[./]*usr/lib/#/\* "/usr/lib/#g' scan_perform.c
+	#this patch is to code Cython copies from itself (Cython/Includes/numpy/__init__.pxd), that only exists in older versions - #918771
 	cd $(CURDIR)/theano/scan_module && dpkg --compare-versions `dpkg-query -f '$${Version}' -W cython3` gt 0.29~ || patch --no-backup-if-mismatch scan_perform.c numpy_api_changes.diff
 	cd $(CURDIR)/theano/scan_module && mv scan_perform.c -t c_code
 	#documentation

=== debian/tests/control ===
Tests: import
Depends: python3-theano
Restrictions: allow-stderr

Tests: selectedupstreamtests
Depends: python3-theano,
 g++,
 python3-pydot,
 python3-nose,
 python3-parameterized,
 python3-pkg-resources,
 cython3,
 graphviz
Restrictions: allow-stderr

# Check that OpenCL isn't totally broken (note that it isn't totally working either)
# Uses device 0 platform 0, i.e. to use a real GPU manually install its opencl-icd before running this
Tests: smoketestgpu
Depends: python3-theano,
 g++,
 python3-pydot,
 python3-nose,
 python3-parameterized,
 python3-pkg-resources,
 cython3,
 graphviz,
 pocl-opencl-icd,
 python3-pygpu,
 libclblas-dev,
 libgpuarray-dev
Restrictions: allow-stderr, skip-not-installable

## theano 1.0.5%2Bdfsg

=== requirements.txt ===
# pip install --upgrade pip setuptools virtualenv virtualenvwrapper virtualenv-clone wheel
# pip install -r requirements.txt && pyenv rehash

cython
# mpi4py
nose
numpy
parameterized
reindent
requests
scipy
six
sympy
